' ------------------------------------------
' Oma-Tutorial
' GTK-Kapitel
' Timeout Example
'
' Needs oma_gtk_timeoutex1.glade
' ------------------------------------------



#include "gtk/gtk.bi"
#include "gtk/libglade/glade-xml.bi"

#ifndef NULL
#define NULL 0
#endif

dim shared as GtkWidget ptr toplevel
dim shared xml as GladeXML ptr
dim shared as guint timeout1id

type tmydata
  sum as integer
  stop1 as gboolean
  start1 as gboolean
  startvalue as integer
end type

dim shared as tmydata mydata


declare sub on_button1_clicked                        cdecl alias "on_button1_clicked" (byval object as GtkObject  ptr, byval user_data as gpointer)

declare sub on_entry1_editing_done                        cdecl alias "on_entry1_editing_done" (byval object as GtkObject  ptr, byval user_data as gpointer)

declare sub on_entry1_changed                        cdecl alias "on_entry1_changed" (byval object as GtkObject  ptr, byval user_data as gpointer)

declare function on_entry1_focus_out_event           cdecl alias "on_entry1_focus_out_event" (byval widget as GtkWidget ptr, byval event as GdkEventFocus ptr, byval user_data as gpointer) as gboolean

declare function on_entry1_key_press_event           cdecl alias "on_entry1_key_press_event" (byval widget as GtkWidget ptr, byval event as GdkEventKey ptr, byval user_data as gpointer) as gboolean

declare sub on_mainwindow_destroy                   cdecl alias "on_mainwindow_destroy" (byval menuitem as GtkMenuItem  ptr, byval user_data as gpointer)

declare function on_vscrollbar1_change_value           cdecl alias "on_vscrollbar1_change_value" (byval r as GtkRange ptr, byval s as GtkScrollType, byval v as gdouble, byval user_data as gpointer) as gboolean

declare sub on_saveasitem_activate cdecl alias "on_saveasitem_activate" (byval menuitem as GtkMenuItem ptr, byval user_data as gpointer)

declare sub on_cancel_save_dialog_clicked                        cdecl alias "on_cancel_save_dialog_clicked" (byval object as GtkObject  ptr, byval user_data as gpointer)

declare function timeout_callback                       cdecl (byval user_data as gpointer) as gboolean

' ------------------------------------------------------------------------------------------------------------

sub textview1_produce()

  dim as GtkTextBuffer ptr buffer
  dim as GtkWidget ptr textview1,entry1
  dim as integer i
  dim as gchar ptr sg
  dim as zstring ptr sz

  if mydata.stop1 then exit sub

  textview1=glade_xml_get_widget( xml, "textview1" )
  entry1=glade_xml_get_widget( xml, "entry1" )
  sz=gtk_entry_get_text(GTK_ENTRY(entry1))

  if mydata.start1 then
    mydata.sum=val(*sz)
    mydata.startvalue=mydata.sum
    mydata.start1=false
  end if

  if mydata.startvalue<>val(*sz) then
    mydata.startvalue=val(*sz)
    mydata.sum=mydata.startvalue
  end if

  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW(textview1))
  'gtk_text_buffer_set_text (buffer, "", -1)

  for i=0 to 0
    gtk_text_buffer_insert_at_cursor(buffer, "Hello, current sum is "+str(mydata.sum)+chr(10), -1)
    mydata.sum=mydata.sum+2
  next i

end sub



' ------------------------------------------------------------------------------------------------------------

sub on_button1_clicked                        cdecl  (byval object as GtkObject  ptr, byval user_data as gpointer) export

  ? "on_Button1_clicked"

  mydata.stop1=true
  'textview1_produce

  'gtk_text_buffer_set_text (buffer, "Hello, this is some text", -1)

end sub


' ------------------------------------------------------------------------------------------------------------

sub on_mainwindow_destroy cdecl (byval menuitem as GtkMenuItem  ptr, byval user_data as gpointer) export

  dim as GtkWidget ptr dialog
  dim as gint res

  g_source_remove(timeout1id)

  dialog = gtk_message_dialog_new (0, _
                                  GTK_DIALOG_DESTROY_WITH_PARENT, _
                                  GTK_MESSAGE_QUESTION, _
                                  GTK_BUTTONS_YES_NO, _
                                  "Speichern?",0)

  res=gtk_dialog_run (GTK_DIALOG(dialog))
  'if (res=GTK_RESPONSE_YES) then ...

  ? "...Peng, wir schliessen..."
  'sleep
  gtk_main_quit()

end sub

' ------------------------------------------------------------------------------------------------------------

sub on_entry1_editing_done                        cdecl (byval object as GtkObject  ptr, byval user_data as gpointer) export

  ? "entry done"

end sub

' ------------------------------------------------------------------------------------------------------------

sub on_entry1_changed                        cdecl (byval object as GtkObject  ptr, byval user_data as gpointer) export

  '? "entry changed"

end sub

' ------------------------------------------------------------------------------------------------------------


function on_entry1_focus_out_event           cdecl (byval widget as GtkWidget ptr, byval event as GdkEventFocus ptr, byval user_data as gpointer) as gboolean export

   ? "Focus out event"

  return false

end function


' ------------------------------------------------------------------------------------------------------------

function on_vscrollbar1_change_value cdecl (byval r as GtkRange ptr, byval s as GtkScrollType, byval v as gdouble, byval user_data as gpointer) as gboolean export

  dim as GtkTextBuffer ptr buffer
  dim as GtkWidget ptr textview1
  dim as GtkTextIter it
  dim as gint nline,posline

  'Writes value in the textview
  textview1=glade_xml_get_widget( xml, "textview1" )
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW(textview1))

  'gtk_text_buffer_set_text (buffer, str(v), -1)
  nline=gtk_text_buffer_get_line_count(buffer)
  posline=int(v/100*nline+0.5)
  'posline=int((sin(v/100*9)+1)/2*nline+0.5)
  '? "Value: ";v,"nline: ";nline,"posline: ";posline
  gtk_text_buffer_get_iter_at_line (buffer, @it, posline)
  gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(textview1),@it,0.4,FALSE,0.5,0)

  return false

end function

' ------------------------------------------------------------------------------------------------------------


sub on_saveasitem_activate cdecl (byval menuitem as GtkMenuItem ptr, byval user_data as gpointer) export

  dim as GtkWidget ptr fcdialog
  dim as gint resp

  fcdialog = glade_xml_get_widget( xml, "filechooserdialog1" )

  resp=gtk_dialog_run(GTK_DIALOG(fcdialog))
  ? "on_saveasitem_activate:",resp

end sub

' ------------------------------------------------------------------------------------------------------------

sub on_cancel_save_dialog_clicked                        cdecl (byval object as GtkObject  ptr, byval user_data as gpointer) export

  dim as GtkWidget ptr fcdialog

  fcdialog = glade_xml_get_widget( xml, "filechooserdialog1" )
  ? "on_cancel_save_dialog_clicked"

  gtk_dialog_response(GTK_DIALOG(fcdialog),2)
  gtk_widget_destroy(fcdialog)

end sub

' ------------------------------------------------------------------------------------------------------------

sub textview1_showtail()

  dim as GtkTextBuffer ptr buffer
  dim as GtkWidget ptr textview1
  dim as GtkTextIter it
  dim as gint nline,posline

  textview1=glade_xml_get_widget( xml, "textview1" )
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW(textview1))
  nline=gtk_text_buffer_get_line_count(buffer)
  gtk_text_buffer_get_iter_at_line (buffer, @it, nline-5)
  gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(textview1),@it,0.4,FALSE,0.5,0)

end sub


' ------------------------------------------------------------------------------------------------------------


function timeout_callback                       cdecl (byval user_data as gpointer) as gboolean export

  textview1_produce
  textview1_showtail

  return true

end function

' ------------------------------------------------------------------------------------------------------------


function on_entry1_key_press_event           cdecl (byval widget as GtkWidget ptr, byval event as GdkEventKey ptr, byval user_data as gpointer) as gboolean export

  ? "Key pressed",event->keyval,event->string

  'UTF-8-coded, take 2nd byte:
  if event->keyval mod &h100 = 13 then textview1_produce

  return false

end function

mydata.sum=0
mydata.stop1=false
mydata.start1=true

gtk_init( NULL, NULL )
xml = glade_xml_new( "oma_gtk_timeoutex1.glade", NULL, NULL )
toplevel = glade_xml_get_widget( xml, "mainwindow" )
gtk_widget_show_all( toplevel )
glade_xml_signal_autoconnect( xml )
timeout1id=g_timeout_add(200,@timeout_callback,NULL)
gtk_main( )


g_object_unref( xml )
end
